searchNodes=[{"doc":"Sorting helpers","ref":"EctoJuno.Helpers.SortingHelpers.html","title":"EctoJuno.Helpers.SortingHelpers","type":"module"},{"doc":"Returns atom representation of string from either list of atoms or Ecto.Schema If not found returns nil","ref":"EctoJuno.Helpers.SortingHelpers.html#map_string_field_to_atom/2","title":"EctoJuno.Helpers.SortingHelpers.map_string_field_to_atom/2","type":"function"},{"doc":"Validator module for sorting parameters","ref":"EctoJuno.Helpers.SortingParams.html","title":"EctoJuno.Helpers.SortingParams","type":"module"},{"doc":"Validation function. Relies on Ecto.Changeset . In the end invokes apply_action!/2 . But it should never raise","ref":"EctoJuno.Helpers.SortingParams.html#changeset!/2","title":"EctoJuno.Helpers.SortingParams.changeset!/2","type":"function"},{"doc":"Module for sorting base query","ref":"EctoJuno.Query.Sorting.html","title":"EctoJuno.Query.Sorting","type":"module"},{"doc":"Sorts query ### Parameters query : the query you want to sort schema_or_allowed_fields : must either be the model's Ecto.Schema either list of atom keys params : map that can have sort_by , sort_direction fields with string values ### Usage defmodule Sample.Accounts do alias EctoJuno.Query.Sorting alias Sample.Accounts.User alias Sample.Repo def sort_users ( sort_by , sort_direction ) do User |&gt; Sorting . sort_query ( User , %{ &quot;sort_by&quot; =&gt; sort_by , &quot;sort_direction&quot; =&gt; sort_direction } ) |&gt; Repo . all ( ) end end You can also pass sort_by and sort_direction as atom keys #### Invoking sort_query/2 Sorting . sort_query ( query , User ) In such case sorting params will be extracted from configuration if exist. If not than default sorting: ascending by inserted_at field will be applied","ref":"EctoJuno.Query.Sorting.html#sort_query/3","title":"EctoJuno.Query.Sorting.sort_query/3","type":"function"},{"doc":"A simple query sorting library","ref":"readme.html","title":"EctoJuno","type":"extras"},{"doc":"Add :ecto_juno to the list of dependencies in mix.exs : def deps do [ { :ecto_juno , git : &quot;https://github.com/senconscious/ecto_juno&quot; } ] end","ref":"readme.html#installation","title":"EctoJuno - Installation","type":"extras"},{"doc":"You can specify default sorting field and mode by adding these lines into your config.exs: config :ecto_juno , sort_by : :id , sort_direction : :desc The default sorting is by inserted_at field with asc mode","ref":"readme.html#configuration","title":"EctoJuno - Configuration","type":"extras"},{"doc":"Assuming you have Accounts context with User schema and Repo module all you need is to pass a ecto schema of model you sorting or list of fields by which sorting can be applied alias EctoJuno.Query.Sorting def list_sorted_users ( params ) do User |&gt; Sorting . sort_query ( User , params ) |&gt; Repo . all ( ) end Where params structure is %{ &quot;sort_by&quot; =&gt; &quot;id&quot; , &quot;sort_direction&quot; =&gt; &quot;desc&quot; } You can also pass sorting parameters keys as atoms: Sorting . sort_query ( query , User , %{ sort_by : &quot;id&quot; , sort_direction : &quot;desc&quot; } ) For missing parameters default sorting ones will be used: # The default sort_direction will be used Sorting . sort_query ( query , User , %{ sort_by : &quot;id&quot; } ) # The default sort_by will be used Sorting . sort_query ( query , User , %{ sort_direction : &quot;desc&quot; } ) # The default sorting which configurable will be used Sorting . sort_query ( query , User ) If you'll pass invalid sorting parameters than default sorting ones will be used for your query: Sorting . sort_query ( query , User , %{ sort_by : &quot;invalid_field&quot; , sort_direction : &quot;invalid_mode&quot; } ) will sort query by inserted_at field with asc mode if configuration not modified Note: Sorting by joint query is not yet supported. Sorting with modes different from asc and desc is not supported No custom validators for parameters yet supported if you pass sort_by and sort_direction values not as strings you'll get exception","ref":"readme.html#usage","title":"EctoJuno - Usage","type":"extras"}]